
public class Colour
{
    private String name;
    
    private int red;
    private int green;
    private int blue;
    
    public Colour(String name, int red, int green, int blue) {
        this.name = name;
        this.red = red;
        this.green = green;
        this.blue = blue;
    }
    
    //equals je ekvivalencia (= R, S, T), konzistentna (pre rovnake X a Y vrati vzdy rovnaky vysledok), a cokolvek.equals(null) je vzdy false
    /*
    @Override
    public boolean equals(Object obj) { //berie Object, nie Colour
        if (this == obj) { //exactly the same object
            return true;
        }
        
        if (! (obj instanceof Colour)) { //instanceof nikdy nehodi NPE; Subclass instanceof Superclass
                                         // obj.getClass() != this.getClass()
                                         // obj.getClass() != Colour.class
            return false;
        }
        
        Colour other = (Colour) obj;
       
        return this.name.equals(other.name);
    }
    
    @Override
    public int hashCode() { //equal objects must have the same hash
        int hash = 17;
        hash = 31*hash + name.hashCode();
        return hash;
    }
    */
    
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        
        if (! (obj instanceof Colour)) {
            return false;
        }
        
        Colour other = (Colour) obj;
       
        return (this.red == other.red) && (this.green == other.green) && (this.blue == other.blue);
    }
    
    @Override
    public int hashCode() {
        int hash = 17;
        hash = 31*hash + red;
        hash = 31*hash + green;
        hash = 31*hash + blue;
        return hash;
    }
}
